Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| fop 1.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.fop.layoutmgr
Class PageBreaker

    java.lang.Object
      org.apache.fop.layoutmgr.AbstractBreaker
          org.apache.fop.layoutmgr.PageBreaker

public class PageBreaker
extends AbstractBreaker

Handles the breaking of pages in an fo:flow

Nested Class Summary

Nested classes inherited from class org.apache.fop.layoutmgr.AbstractBreaker
`AbstractBreaker.BlockSequence, AbstractBreaker.PageBreakPosition`

Field Summary

Fields inherited from class org.apache.fop.layoutmgr.AbstractBreaker
`alignment, footnoteSeparatorLength, log`

Constructor Summary
`PageBreaker(PageSequenceLayoutManager pslm)`

Method Summary
`protected void` | `addAreas(PositionIterator posIter, LayoutContext context)` Adds an area to the flow layout manager
`protected PageBreakingAlgorithm.PageBreakingLayoutListener` | `createLayoutListener()` Creates and returns a PageBreakingLayoutListener for the PageBreakingAlgorithm to notify about layout problems.
`protected void` | `doPhase3(org.apache.fop.layoutmgr.PageBreakingAlgorithm alg, int partCount, AbstractBreaker.BlockSequence originalList, AbstractBreaker.BlockSequence effectiveList)` Phase 3 of Knuth algorithm: Adds the areas This implementation checks whether to trigger column-balancing, or whether to take into account a 'last-page' condition.
`protected void` | `finishPart(org.apache.fop.layoutmgr.PageBreakingAlgorithm alg, AbstractBreaker.PageBreakPosition pbp)`
`protected LayoutManager` | `getCurrentChildLM()`
`protected int` | `getCurrentDisplayAlign()`
`protected int` | `getNextBlockList(LayoutContext childLC, int nextSequenceStartsOn)` Gets the next block list (sequence) and adds it to a list of block lists if it's not empty.
`protected int` | `getNextBlockList(LayoutContext childLC, int nextSequenceStartsOn, Position positionAtIPDChange, LayoutManager restartLM, java.util.List firstElements)` Gets the next block list (sequence) and adds it to a list of block lists if it's not empty.
`protected java.util.List` | `getNextKnuthElements(LayoutContext context, int alignment)`
`protected java.util.List` | `getNextKnuthElements(LayoutContext context, int alignment, Position positionAtIPDChange, LayoutManager restartAtLM)`
`protected PageProvider` | `getPageProvider()` Returns the PageProvider if any. PageBreaker overrides this method because each page may have a different available BPD which needs to be accessible to the breaking algorithm.
`protected LayoutManager` | `getTopLevelLM()`
`protected void` | `handleEmptyContent()` This method is called when no content is available for a part. Used to force empty pages.
`protected int` | `handleSpanChange(LayoutContext childLC, int nextSequenceStartsOn)` Handles span changes reported through the `LayoutContext`. Only used by the PSLM and called by `getNextBlockList()`.
`protected boolean` | `hasMoreContent()`
`protected void` | `observeElementList(java.util.List elementList)` Used for debugging purposes. Notifies all registered observers about the element list. Override to set different parameters.
`protected void` | `startPart(AbstractBreaker.BlockSequence list, int breakClass)`
`protected void` | `updateLayoutContext(LayoutContext context)` Used to update the LayoutContext in subclasses prior to starting a new element list.

Methods inherited from class org.apache.fop.layoutmgr.AbstractBreaker
`addAreas, addAreas, createLayoutContext, doLayout, isEmpty, isPartOverflowRecoveryActivated, isSinglePartFavored`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PageBreaker

    public PageBreaker(PageSequenceLayoutManager pslm)

Method Detail

### updateLayoutContext

    protected void updateLayoutContext(LayoutContext context)

  Used to update the LayoutContext in subclasses prior to starting a new element list.

  Overrides:
    `updateLayoutContext` in class `AbstractBreaker`
  Parameters:
    `context` - the LayoutContext to update

### getTopLevelLM

    protected LayoutManager getTopLevelLM()

  Specified by:
    `getTopLevelLM` in class `AbstractBreaker`

### getPageProvider

    protected PageProvider getPageProvider()

  Returns the PageProvider if any. PageBreaker overrides this method because each page may have a different available BPD which needs to be accessible to the breaking algorithm.

  Overrides:
    `getPageProvider` in class `AbstractBreaker`
  Returns:
    the applicable PageProvider, or null if not applicable

### createLayoutListener

    protected PageBreakingAlgorithm.PageBreakingLayoutListener createLayoutListener()

  Creates and returns a PageBreakingLayoutListener for the PageBreakingAlgorithm to notify about layout problems.

  Overrides:
    `createLayoutListener` in class `AbstractBreaker`
  Returns:
    the listener instance or null if no notifications are needed

### handleSpanChange

    protected int handleSpanChange(LayoutContext childLC,
                                   int nextSequenceStartsOn)

  Handles span changes reported through the `LayoutContext`. Only used by the PSLM and called by `getNextBlockList()`.

  Overrides:
    `handleSpanChange` in class `AbstractBreaker`
  Parameters:
    `childLC` - the LayoutContext
    `nextSequenceStartsOn` - previous value for break handling
  Returns:
    effective value for break handling

### getNextBlockList

    protected int getNextBlockList(LayoutContext childLC,
                                   int nextSequenceStartsOn)

  Gets the next block list (sequence) and adds it to a list of block lists if it's not empty.

  Overrides:
    `getNextBlockList` in class `AbstractBreaker`
  Parameters:
    `childLC` - LayoutContext to use
    `nextSequenceStartsOn` - indicates on what page the next sequence should start
  Returns:
    the page on which the next content should appear after a hard break

### getNextBlockList

    protected int getNextBlockList(LayoutContext childLC,
                                   int nextSequenceStartsOn,
                                   Position positionAtIPDChange,
                                   LayoutManager restartLM,
                                   java.util.List firstElements)

  Gets the next block list (sequence) and adds it to a list of block lists if it's not empty.

  Overrides:
    `getNextBlockList` in class `AbstractBreaker`
  Parameters:
    `childLC` - LayoutContext to use
    `nextSequenceStartsOn` - indicates on what page the next sequence should start
    `positionAtIPDChange` - last element on the part before an IPD change
    `restartLM` - the layout manager from which to restart, if IPD change occurs between two LMs
    `firstElements` - elements from non-restartable LMs on the new page
  Returns:
    the page on which the next content should appear after a hard break

### getNextKnuthElements

    protected java.util.List getNextKnuthElements(LayoutContext context,
                                                  int alignment)

  Specified by:
    `getNextKnuthElements` in class `AbstractBreaker`

### getNextKnuthElements

    protected java.util.List getNextKnuthElements(LayoutContext context,
                                                  int alignment,
                                                  Position positionAtIPDChange,
                                                  LayoutManager restartAtLM)

  Overrides:
    `getNextKnuthElements` in class `AbstractBreaker`

### getCurrentDisplayAlign

    protected int getCurrentDisplayAlign()

  Specified by:
    `getCurrentDisplayAlign` in class `AbstractBreaker`
  Returns:
    current display alignment

### hasMoreContent

    protected boolean hasMoreContent()

  Specified by:
    `hasMoreContent` in class `AbstractBreaker`
  Returns:
    whether or not this flow has more page break opportunities

### addAreas

    protected void addAreas(PositionIterator posIter,
                            LayoutContext context)

  Adds an area to the flow layout manager

  Specified by:
    `addAreas` in class `AbstractBreaker`
  Parameters:
    `posIter` - the position iterator
    `context` - the layout context

### doPhase3

    protected void doPhase3(org.apache.fop.layoutmgr.PageBreakingAlgorithm alg,
                            int partCount,
                            AbstractBreaker.BlockSequence originalList,
                            AbstractBreaker.BlockSequence effectiveList)

  Phase 3 of Knuth algorithm: Adds the areas This implementation checks whether to trigger column-balancing, or whether to take into account a 'last-page' condition.

  Specified by:
    `doPhase3` in class `AbstractBreaker`
  Parameters:
    `alg` - PageBreakingAlgorithm instance which determined the breaks
    `partCount` - number of parts (pages) to be rendered
    `originalList` - original Knuth element list
    `effectiveList` - effective Knuth element list (after adjustments)

### startPart

    protected void startPart(AbstractBreaker.BlockSequence list,
                             int breakClass)

  Overrides:
    `startPart` in class `AbstractBreaker`

### handleEmptyContent

    protected void handleEmptyContent()

  This method is called when no content is available for a part. Used to force empty pages.

  Overrides:
    `handleEmptyContent` in class `AbstractBreaker`

### finishPart

    protected void finishPart(org.apache.fop.layoutmgr.PageBreakingAlgorithm alg,
                              AbstractBreaker.PageBreakPosition pbp)

  Specified by:
    `finishPart` in class `AbstractBreaker`

### getCurrentChildLM

    protected LayoutManager getCurrentChildLM()

  Specified by:
    `getCurrentChildLM` in class `AbstractBreaker`
  Returns:
    the current child flow layout manager

### observeElementList

    protected void observeElementList(java.util.List elementList)

  Used for debugging purposes. Notifies all registered observers about the element list. Override to set different parameters.

  Overrides:
    `observeElementList` in class `AbstractBreaker`
  Parameters:
    `elementList` - the Knuth element list

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| fop 1.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 1999-2010 The Apache Software Foundation. All Rights Reserved.